config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  mount LetterOpenerWeb::Engine, at: "/letter_opener" if Rails.env.development?

  devise_for :users, path: 'accounts', controllers: { registrations: 'users/registrations'}

  devise_scope :user do
    authenticated :user do
      root 'user_records#index'
    end

    unauthenticated do
      root 'devise/sessions#new', as: :unauthenticated_root
    end
  end

  resources :medical_histories, except: [:show, :destroy] do
    collection do
      get :add_attribute
    end
  end
  resources :personal_data, except: [:show, :destroy] do
    collection do
      get :add_attribute
    end
  end

  resources :users, only: [:show]
  resources :user_records, only: [:index, :show, :edit, :update, :destroy] do
    member do
      post :view
      get :view
      get :share
      post :share
      get :share_form
      get :edit_data
      post :edit_data
    end
    resources :share_keys
  end

end

app/views/shared/_add_button.html.haml
= link_to '#', class: "ui green right labeled icon button add-button #{type}", id: "add-#{object.dasherize}", data: {collection: "#{object.dasherize.pluralize}", object: "#{object}"} do
    = "Add #{t(object.to_sym, scope: [:models])}"
    %i.plus.right.icon

app/views/shared/_empty_placeholder.html.haml
.ui.placeholder.segment
    .ui.icon.header
        %i.info.circle.icon
        = "No #{object.titleize} Found"

app/views/shared/_horizontal_table.html.haml
- headers = hashes.first.keys
- excluded = %w(errors validation_context)
.container
    %table.table.is-bordered.is-fullwidth.is-striped
        %thead
            %tr
                - headers.each do |header|
                    - next if header.in?(excluded)
                    %th
                        = t(header, scope: [:labels, type.to_sym, section.to_sym])
        %tbody
            - hashes.each do |hash|
                %tr
                    - hash.each do |key, value|
                        - next if key.in?(excluded)
                        %td= value

app/views/shared/_items.html.haml
.ui.segment
    %table.ui.table.celled.striped.selectable
        %thead
            %tr
                %th Record ID
                %th Type
                %th Owner
                %th Actions
        %tbody    
            - user_records.each do |record|
                %tr
                    %td= record.id
                    %td= t(record.phr_type.to_sym, scope: :phr_types)
                    %td= link_to User.find(record.user_id).fullname, user_path(record.user_id)
                    %td
                        = link_to user_record_path(record.id) do
                            %i.eye.icon
                        - if record.user_id == current_user.id && record.phr_type.present?
                            = link_to eval("edit_user_record_path(record.id)") do
                                %i.edit.icon 
                            = link_to user_record_path(record), title: 'Delete User Record', remote: true, method: :delete, data: {confirm: "Are you sure you want to delete this user record?"} do
                                %i.trash.icon
                            = link_to share_form_user_record_path(record) do
                                %i.share.icon

app/views/shared/_remove_button.html.haml
.remove-attribute
    %i.close.icon